local delay = 2	--time to wait before taking the screenshot
local counter = 0
local setgrab = nil
local f = CreateFrame("frame")

local validSortTypes = {"class","cp","damage","deaths","healing","hk","kills","name","stat1","stat2","stat3","stat4","stat5","stat6","stat7","team"}

if not BGScoreShot_Variables then
	BGScoreShot_Variables = {}
end

if not BGScoreShot_Variables.sortType then
	BGScoreShot_Variables.sortType = "cp"
end

local localisedText = { ["LOADED"] = "BGScoreShot - Loaded.", ["HORDE_WINS"] = "The Horde wins!", ["ALLIANCE_WINS"] = "The Alliance wins!", ["TIE_GAME"] = "Tie game!", ["TRIGGERED"] = "BGScoreShot - Triggered." }
--[[
if GetLocale() =="deDE"     then localisedText = { ["LOADED"] = "BGScoreShot - Loaded.", ["HORDE_WINS"] = "The Horde wins!", ["ALLIANCE_WINS"] = "The Alliance wins!", ["TRIGGERED"] = "BGScoreShot - Triggered." }
elseif GetLocale() =="esES" then localisedText = { ["LOADED"] = "BGScoreShot - Loaded.", ["HORDE_WINS"] = "The Horde wins!", ["ALLIANCE_WINS"] = "The Alliance wins!", ["TRIGGERED"] = "BGScoreShot - Triggered." }
elseif GetLocale() =="frFR" then localisedText = { ["LOADED"] = "BGScoreShot - Loaded.", ["HORDE_WINS"] = "The Horde wins!", ["ALLIANCE_WINS"] = "The Alliance wins!", ["TRIGGERED"] = "BGScoreShot - Triggered." }
end
--]]

f:RegisterEvent("CHAT_MSG_BG_SYSTEM_ALLIANCE")
f:RegisterEvent("CHAT_MSG_BG_SYSTEM_HORDE")
f:RegisterEvent("CHAT_MSG_BG_SYSTEM_NEUTRAL")

DEFAULT_CHAT_FRAME:AddMessage("|cFFFF00FF"..localisedText["LOADED"].."|r")

f:SetScript("OnEvent", function(self, event, ...)
	if (event == ("CHAT_MSG_BG_SYSTEM_ALLIANCE")) or (event == ("CHAT_MSG_BG_SYSTEM_HORDE")) or (event == ("CHAT_MSG_BG_SYSTEM_NEUTRAL")) then
		print("bg message happened")
		local message = ...
		print(message)
		if (message == localisedText["HORDE_WINS"]) or (message == localisedText["ALLIANCE_WINS"]) or (message == localisedText["TIE_GAME"]) then
			print("bg message was a win or draw")
			SetBattlefieldScoreFaction(nil)
			local unSort
			if BGScoreShot_Variables.sortType == "hk" then
				unSort = "cp"
			else
				unSort = "hk"
			end
			SortBattlefieldScoreData(unSort)
			setgrab = 1
		end
	end
end
)
.
f:SetScript("OnUpdate", function(self, elapsed)
	if setgrab then
		counter = counter + elapsed
		if (counter >= delay) then
			if setgrab == 1 then
				SortBattlefieldScoreData(BGScoreShot_Variables.sortType)
				counter = 0
				setgrab = 2
			elseif setgrab == 2 then
				Screenshot()
				DEFAULT_CHAT_FRAME:AddMessage("|cFFFF00FF"..localisedText["TRIGGERED"].."|r")
				counter = 0
				setgrab = nil
			end
		end
	end
end
)

local commandTableA = {
	["sort"] = function(sType)	
		BGScoreShot_Variables.sortType = sType
	end,	
	["default"] = function()
		DEFAULT_CHAT_FRAME:AddMessage("|cFFFF00FF\nCurrent sort type is: ".. BGScoreShot_Variables.sortType .. ".\n\nPermissible sort orders for the scoreboard are: class, cp (honor gained), damage, deaths, healing, hk (honor kills), kills, name, team, stat1 (to 7, where the stats are objectives specific to the game type).  Select one by entering eg. \"/bgss hk\".")
	end,
}

local function runSlashCommandA(message, cmdTable)
	local command, parameters = string.split(" ", message, 2)
	if (command == nil) or (command == "") then
		commandTableA.default()
	elseif tContains(validSortTypes, command) then
		commandTableA.sort(command)
	end
end

SLASH_BGSS1 = "/bgss"
SlashCmdList["BGSS"] = function(txt)
	runSlashCommandA(txt, commandTableA)
end

















